function WG0() {
var canvas=document.getElementById("canvas");
var ctx=canvas.getContext('2d');
var anim_phase=0;
var anim_nb_phases=5;
var anim_t=0;
var anim_speed;
var OFF = {x:canvas.width/2, y:canvas.height/2};
var SCALE = 150;
var pi=Math.PI;
var tau=2*pi;
var timer=0;
var setAnimSpeed=function() {
  if(anim_phase==0) anim_speed=0.01;
  if(anim_phase==1) anim_speed=0.01;
  if(anim_phase==2) anim_speed=0.003;
  if(anim_phase==3) anim_speed=0.001;
  if(anim_phase==4) anim_speed=0.002;
}
setAnimSpeed();
function math_to_phys(p) {
  return({
    x: OFF.x  + SCALE*p.x
   ,y: OFF.y  - SCALE*p.y
  });
}
function vec_to_phys(v) {
 return ({x: v.x*SCALE, y:-v.y*SCALE});
}
/*
function phys_to_math(p) {
  return({
    x: (p.x-OFF.x)/SCALE
   ,y: (OFF.y-p.y)/SCALE
  });
}
*/
var norm=function(v) {
  return(Math.sqrt(v.x*v.x+v.y*v.y));
}
var animate=function() {
  anim_t += anim_speed/norm(df(anim_t));
  if(anim_t>1) {
    anim_t=1;
    draw();
    clearInterval(timer);
    timer=0;
  }
  draw();
}
var aoff=tau/6.3;
var f=function(t) {
  var a=tau*t;
  if(anim_phase==0)
    return({x:  Math.cos(a), y:Math.sin(a) });
  if(anim_phase==1)
    return({x:  Math.cos(tau/2-a), y:Math.sin(tau/2-a) });
  if(anim_phase==2)
    return({x:  Math.cos(a), y: 0.5*Math.sin(2*a) });
  if(anim_phase==3) {
    var c=Math.cos(a-aoff);
    var s=Math.sin(a-aoff);
    return({
      x: (c-c*c*0.6-c*c*c*0.4)+0.5
     ,y: (s-3*s*(2*c*c-1))/5
    });
  }
  if(anim_phase==4) {
    var c=Math.cos(a);
    var s=Math.sin(a);
    return({
      x: (c+0.5*(c*c*c*c-6*c*c*s*s+s*s*s*s))/2 // (c+0.5*(1-8*s*s+8*s*s*s*s))/2
     ,y: (s+0.5*(4*c*c*c*s-4*c*s*s*s))/2 // (s+0.5*(4*c*s-8*c*s*s*s))/2
    });
  }
}
var df=function(t) {
  var a=tau*t;
  if(anim_phase==0)
    return({x: -Math.sin(a), y:Math.cos(a) });
  if(anim_phase==1)
    return({x: Math.sin(tau/2-a), y:-Math.cos(tau/2-a) });
  if(anim_phase==2)
    return({x: -Math.sin(a), y:Math.cos(2*a) });
  if(anim_phase==3) {
    var c=Math.cos(a-aoff);
    var s=Math.sin(a-aoff);
    return({
      x: (-s+2*s*c*0.6+3*s*c*c*0.4)
     ,y: (c-3*(c-2*3*c*s*s))/5
    });
  }
  if(anim_phase==4) {
    var c=Math.cos(a);
    var s=Math.sin(a);
    return({
      x: (-s+0.5*8*c*s*(-2+4*s*s))/2
     ,y: (c+0.5*(4*(c*c-s*s)-8*(3*c*c*s*s-s*s*s*s)))/2
    });
  }
}
var draw_form=function() {
  N=150;
  ctx.beginPath();
  var m=math_to_phys(f(0));
  ctx.moveTo(m.x,m.y);
  for(var i=1; i<=N; i++) {
    m=math_to_phys(f(i/N));
    ctx.lineTo(m.x,m.y);
  }
  ctx.stroke();
}
var draw_vect=function() {
  var p=f(anim_t);
  var v=df(anim_t);
  var d=norm(v);
  v.x /= d; v.y /=d;
  var s=0.3;
  v.x *= s; v.y *=s;
  d=vec_to_phys(v);
  var m=math_to_phys(p);
  for(var i=0; i<2; i++) {
    ctx.beginPath();
    ctx.moveTo(m.x,m.y);
    ctx.lineTo(m.x+d.x,m.y+d.y);
    ctx.moveTo(m.x+d.x*0.8-d.y*0.15,m.y+d.y*0.8+d.x*0.15);
    ctx.lineTo(m.x+d.x,m.y+d.y);
    ctx.lineTo(m.x+d.x*0.8+d.y*0.15,m.y+d.y*0.8-d.x*0.15);
    ctx.stroke();
    ctx.beginPath();
    ctx.arc(m.x,m.y,5,0,tau);
    ctx.fill();
    m=math_to_phys({x:1.8, y:0});
    ctx.beginPath();
    ctx.arc(m.x,m.y,SCALE*s*1.1,0,tau);
    ctx.stroke();
  }
}
var draw=function() {
  ctx.clearRect(0,0,canvas.width,canvas.height);
  ctx.strokeStyle="black";
  ctx.lineWidth=2;
  draw_form();
  ctx.strokeStyle="red";
  ctx.fillStyle="red";
  ctx.lineWidth=3;
  draw_vect();
}
var onAnimPlay=function() {
  anim_t=0;
  if(timer==0) {
    timer=setInterval(animate,25);
  }
  else {
    clearInterval(timer);
    timer=0;
  }
}
var onAnimNext=function() {
  if(timer==0) {
  }
  else {
    clearInterval(timer);
    timer=0;
  }
  anim_phase += 1;
  if(anim_phase>=anim_nb_phases) { anim_phase=0; }
  setAnimSpeed();
  anim_t=0;
  draw();
}
var button=document.getElementById("play1");
button.onclick=onAnimPlay;
button=document.getElementById("next1");
button.onclick=onAnimNext;

draw();
}