function WG1() {
var tau=2*Math.PI;
var SCALE_WG=100;

var norm=function(v) {
  return(Math.sqrt(v.x*v.x+v.y*v.y));
}
function g(a) {
  var t=a*tau;
  var c=Math.cos(t);
  var s=Math.sin(t);
  return({
    x: (c-c*c*0.6-c*c*c*0.4)+0.5
   ,y: (s-3*s*(2*c*c-1))/5
  });
}
function dg(a) {
  var t=a*tau;
  var c=Math.cos(t);
  var s=Math.sin(t);
  return({
    x: tau*(-s+2*s*c*0.6+3*s*c*c*0.4)
   ,y: tau*(c-3*(c-2*3*c*s*s))/5
  });
}
function mpWG(p) {
  return {
    x: canvasWG.width/2   + SCALE_WG*p.x
   ,y: canvasWG.height/2  - SCALE_WG*p.y
  };
}
function vpWG(v) {
 return ({x: v.x*SCALE_WG, y:-v.y*SCALE_WG});
}

var curve1=[];
var dir1=[];
var spd=0.005;
for(var t=0; t<1; ) {
  var p=g(t);
  curve1.push(p)
  t += spd/norm(dg(t));
}
var N1=curve1.length;
var aux=0;
var v={x:0,y:1};
for(var i=0; i<N1; i++) {
  var q=curve1[i];
  var p=curve1[(i+1)%N1];
  var nv={x:p.x-q.x, y:p.y-q.y};
  var r=norm(nv);
  aux += Math.atan2(nv.y*v.x-nv.x*v.y,nv.x*v.x+nv.y*v.y);
  dir1.push({x:r, y:aux});
  v=nv;
}

var curve2=[];
var dir2=[];
var r=N1*spd/tau;
v=tau/4;
for(var i=0; i<N1; i++) {
  var t=i/N1*tau;
  curve2.push({x:Math.cos(t+tau/2)*r, y:Math.sin(t+tau/2)*r});
}
aux=0;
v={x:0,y:1};
for(var i=0; i<N1; i++) {
  var q=curve2[i];
  var p=curve2[(i+1)%N1];
  var nv={x:p.x-q.x, y:p.y-q.y};
  var r=norm(nv);
  aux += Math.atan2(nv.y*v.x-nv.x*v.y,nv.x*v.x+nv.y*v.y);
  var temp={x:r, y:aux};
  dir2.push({x:r, y:aux});
  v=nv;
}

var canvasWG=document.getElementById("canvas2");
var ctxWG=canvasWG.getContext("2d");
var curve=[];
var WG=function(t) {
  var x=0,y=0;
  curve=[{x:x,y:y}];
  for(var i=1; i<N1; i++) {
    var a=(1-t)*dir1[i].y+t*dir2[i].y;
    var r=(1-t)*dir1[i].x+t*dir2[i].x;
    x += r*Math.cos(a);
    y += r*Math.sin(a);
    curve.push({x:x,y:y});
  }
  var bx=0,by=0;
  for(var i=1; i<N1; i++) {
    var s=i/N1;
    curve[i].x -= s*x;
    curve[i].y -= s*y;
    bx += curve[i].x;
    by += curve[i].y;
  }
  bx /= N1;
  by /= N1;
  for(var i=0; i<N1; i++) {
    var s=i/N1;
    curve[i].x -= bx;
    curve[i].y -= by;
  }
}
var drawWG=function() {
  ctxWG.clearRect(0,0,canvasWG.width,canvasWG.height);
/*  ctxWG.fillStyle="red";
  ctxWG.beginPath();
  var aux=mpWG(curve[0]);
  ctxWG.arc(aux.x,aux.y,5,0,360);
  ctxWG.fill();*/
  ctxWG.lineWidth=2;
  ctxWG.beginPath();
  var m=mpWG(curve[0]);
  ctxWG.moveTo(m.x,m.y);
  for(var i=1; i<N1; i++) {
    m=mpWG(curve[i]);
    ctxWG.lineTo(m.x,m.y);
  }
  m=mpWG(curve[0]);
  ctxWG.lineTo(m.x,m.y);
  ctxWG.stroke();
}
var timeWG=0;
var dirWG=true;
var timerWG=0;
var msWG=20;
var WGspeed=5;
var WGTimer=function() {
  timeWG += msWG/1000/WGspeed;
  if(timeWG>1) {
/*    timeWG=1;
    WG(dirWG ? timeWG : 1-timeWG);
    drawWG();*/
    clearInterval(timerWG);
    timerWG=0;
    timeWG=0;
    dirWG = !dirWG;
  }
  WG(dirWG ? timeWG : 1-timeWG);
  drawWG();
}
var onWGPlay=function() {
  timeWG=0;
  if(timerWG==0)
    timerWG=setInterval(WGTimer,msWG);
}
var onWGRewind=function() {
  if(timerWG!=0)
    clearInterval(timerWG);
  timerWG=0;
  timeWG=0;
  dirWG=true;
  WG(timeWG);
  drawWG();
}

var button=document.getElementById("play2");
button.onclick=onWGPlay;
button=document.getElementById("rewind2");
button.onclick=onWGRewind;

WG(timeWG);
drawWG();
}