function WG2() {

var tau=2*Math.PI;
var SCALE=100;

var prox = function(x) {
  return Math.floor(x+0.5);
}

var norm=function(v) {
  return(Math.sqrt(v.x*v.x+v.y*v.y));
}

var arc=1/18;

function lin(a,b,t) {
  return((1-t)*a+t*b);
}

function polar(r,th) {
  var rh=Math.exp(r-1);
  return({
    x:rh*Math.cos(th)
   ,y:rh*Math.sin(th)
  });
}

var st=2*arc+(1-2*arc)/9;
var h=1.0*arc*tau;

function g(s0,t) { // s0 : arc parameter, t: time parameter
  var s=s0*st;
  if(s<arc) {
    var x=s/arc; 
    var r=1-h*(1-Math.cos(tau*x))/2;
    var th=tau*arc*(x*(4*x-3)*(4*x-3));
    return polar(r,th);
  }
  var u=lin(arc,st-arc,t);
  var v=lin(arc,1-arc,t);
  if(s<u)
    return polar(1,tau*lin(arc,v,(s-arc)/(u-arc)));
  if(s<arc+u) { 
    var x=(s-u)/arc;
    var r=1+h*(1-Math.cos(tau*x))/2;
    var th=tau*(v+arc*x*(4*x-3)*(4*x-3));
    return polar(r,th);
  }
  return polar(1,tau*lin(v+arc,1,(s-(u+arc))/(st-(u+arc))));
}
function mp(p) {
  return {
    x: canvas.width/2   + SCALE*p.x
   ,y: canvas.height/2  - SCALE*p.y
  };
}
function vp(v) {
 return {x: v.x*SCALE, y:-v.y*SCALE};
}

var canvas=document.getElementById("canvas3");
var ctx=canvas.getContext("2d");
var curve=[];

function WG(tm,ti) {
  var curve1=[];
  var dir1=[];
  var spd=0.005;
  for(var t=0; t<1; ) {
    var p=g(t,ti);
    curve1.push(p);
    t += spd;
  }
  N1=curve1.length;
  var aux=0;
  var v={x:0,y:1};
  var L1=0;
  var len1=[];
  for(var i=0; i<=N1; i++) {
    var q=curve1[i%N1];
    var p=curve1[(i+1)%N1];
    var nv={x:p.x-q.x, y:p.y-q.y};
    var r=norm(nv);
    var naux = Math.atan2(nv.y,nv.x); 
    aux = naux - tau*prox((naux-aux)/tau); 
    dir1.push({x:r, y:aux});
    len1.push(L1);
    if(i<N1) L1 += r;
    v=nv;
  }

  var curve2=[];
  var dir2=[];
  var r=L1/tau;
  for(var i=0; i<N1; i++) {
    var th=tau*len1[i]/L1;
    curve2.push(polar(r,th));
  }
  aux=0;
  v={x:0,y:1};
  for(var i=0; i<=N1; i++) {
    var q=curve2[i%N1];
    var p=curve2[(i+1)%N1];
    var nv={x:p.x-q.x, y:p.y-q.y};
    var r=norm(nv);
    var naux = Math.atan2(nv.y,nv.x);
    aux = naux - tau*prox((naux-aux)/tau);
    var temp={x:r, y:aux};
    dir2.push({x:r, y:aux});
    v=nv;
  }
  
  var x=0,y=0;
  curve=[{x:x,y:y}];
  for(var i=1; i<=N1; i++) {
    var a=(1-tm)*dir1[i].y+tm*dir2[i].y;
    var r=(1-tm)*dir1[i].x+tm*dir2[i].x;
    x += r*Math.cos(a);
    y += r*Math.sin(a);
    if(i<N1) curve.push({x:x,y:y});
  }
  var bx=0,by=0;
  for(var i=1; i<N1; i++) {
    var s=len1[i]/L1;
    curve[i].x -= s*x;
    curve[i].y -= s*y;
    var ds=(len1[i]-len1[i-1])/L1;
    bx += ds*curve[i].x;
    by += ds*curve[i].y;
  }
//  bx /= N1;
//  by /= N1;
  redr={x:curve[1].x-curve[0].x
       ,y:curve[1].y-curve[0].y};
  var d=norm(redr);
  redr.x /= d;
  redr.y /= d;
  redr.y = -redr.y;
  redr={x:-redr.y,y:redr.x};
  for(var i=0; i<N1; i++) {
    curve[i].x -= bx;
    curve[i].y -= by;
    var nx = curve[i].x*redr.x - curve[i].y*redr.y;
    var ny = curve[i].x*redr.y + curve[i].y*redr.x;
    curve[i].x = nx;
    curve[i].y = ny;
  }
}


var draw_vect=function(p,v) {
  var d=vp(v);
  var m=mp(p);
  for(var i=0; i<2; i++) {
    ctx.beginPath();
    ctx.moveTo(m.x,m.y);
    ctx.lineTo(m.x+d.x,m.y+d.y);
    ctx.moveTo(m.x+d.x*0.8-d.y*0.15,m.y+d.y*0.8+d.x*0.15);
    ctx.lineTo(m.x+d.x,m.y+d.y);
    ctx.lineTo(m.x+d.x*0.8+d.y*0.15,m.y+d.y*0.8-d.x*0.15);
    ctx.stroke();
    ctx.beginPath();
    ctx.arc(m.x,m.y,5,0,tau);
    ctx.fill();
  }
}

var draw=function() {
  ctx.clearRect(0,0,canvas.width,canvas.height);
  ctx.lineWidth=2;

  ctx.fillStyle="red";
/*  ctx.beginPath();
  ctx.arc(m.x,m.y,4,0,tau);
  ctx.fill();*/
  ctx.strokeStyle="red";
  var ve={x:curve[1].x-curve[0].x,y:curve[1].y-curve[0].y};
  var d=norm(ve);
  d=0.5/d;
  ve.x *= d;
  ve.y *= d;
//  draw_vect(curve[0],{x:0,y:0.5});
  draw_vect(curve[0],ve);

  ctx.strokeStyle="black";
  ctx.beginPath();
  var m=mp(curve[0]);
  ctx.moveTo(m.x,m.y);
  var N1=curve.length;
  for(var i=1; i<N1; i++) {
    m=mp(curve[i]);
    ctx.lineTo(m.x,m.y);
  }
  m=mp(curve[0]);
  ctx.lineTo(m.x,m.y);
  ctx.stroke();
}

function getMousePos(evt) {
  var rect = canvas.getBoundingClientRect();
  return {
    x: evt.clientX - rect.left,
    y: evt.clientY - rect.top
  };
}
var onWGMove=function(ev) {
  var m=getMousePos(ev);
  WG(m.y/canvas.height,m.x/canvas.width);
  draw();
}

var update=function(ev) {
  WG(1-sliderUnfold.value/sliderUnfold.max,sliderPos.value/sliderPos.max);
  draw();
}

//canvas.onmousemove=onWGMove;

var sliderUnfold=document.getElementById("slider3a");
var sliderPos=document.getElementById("slider3b");
sliderUnfold.value = sliderUnfold.max;
sliderPos.value = 0;
sliderUnfold.oninput = update;
sliderPos.oninput = update;


WG(0,0);
draw();
}