function WG3() {

var tau=2*Math.PI;
var SCALE=70;
var OFF={x:-250, y:180};

var prox = function(x) {
  return Math.floor(x+0.5);
}

var norm=function(v) {
  return(Math.sqrt(v.x*v.x+v.y*v.y));
}

function lin(a,b,t) {
  return((1-t)*a+t*b);
}

/*function polar(r,th) {
  var rh=Math.exp(r-1);
  return({
    x:rh*Math.cos(th)
   ,y:rh*Math.sin(th)
  });
}*/

var R1=1.;
var R2=1./3.;
var alpha=tau/6.;

var L1=alpha*R1 ; // arclength before rescaling of first circular arc
var L2=(tau-2*alpha)*R2 ; // of second circular arc
var L=2*L1+L2 ; // of all

function g(s,t) { // s : arc parameter, t: time parameter
  
  if(t==0) return {x:L*s, y:0};

  var p={x:0,y:0};
  var u;
  
  var s=s*L;
  u=Math.min(alpha,s/R1);
  p.x += Math.sin(u*t)*R1/t;
  p.y += (1-Math.cos(u*t))*R1/t;
  s=s-L1;
  if(s<0) return p;
  u=Math.min(tau-2*alpha,s/R2);
  p.x += (Math.sin((alpha+u)*t)-Math.sin(alpha*t))*R2/t;
  p.y += (Math.cos(alpha*t)-Math.cos((alpha+u)*t))*R2/t;
  s=s-L2;
  if(s<0.) return p;
  u=Math.min(alpha,s/R1);
  p.x += (Math.sin((u+tau-alpha)*t)-Math.sin((tau-alpha)*t))*R1/t;
  p.y += (Math.cos((tau-alpha)*t)-Math.cos((u+tau-alpha)*t))*R1/t;
  return p;
}

var X0=g(1,1).x;

function mp(p) {
  return {
    x: canvas.width/2   + SCALE*p.x + OFF.x
   ,y: canvas.height/2  - SCALE*p.y + OFF.y
  };
}
function vp(v) {
 return {x: v.x*SCALE, y:-v.y*SCALE};
}

var canvas=document.getElementById("canvasBM");
var ctx=canvas.getContext("2d");
var curve=[];

function WG(ti) {
  curve=[];
  var N=200;
  for(var i=0; i<=N; i++) 
    curve.push(g(i/N,ti));
  if(cbCorrect1.checked) {
    var c=curve[curve.length-1];
    var x=c.x-X0;
    var y=c.y;
    var s,a;
    for(var i=1; i<=N; i++) {
      s=i/N;
      curve[i].x -= s*x;
      curve[i].y -= s*y;
    }
    if(cbCorrect2.checked) {
      for(var i=1; i<=N; i++) {
        s=i/N;
        a=(1-ti)*0.35;
        if(s==0) curve[i].y=0;
        else curve[i].y *= s/(Math.sqrt(a*a+s*s)+a)*(Math.sqrt(a*a+1.)+a);
       // console.log(a,s,s/(Math.sqrt(a*a+s*s)+a)*(Math.sqrt(a*a+1.)+a));
//        return (1./l)*p-point(0.5,0,0);
      }
    }
  }
}


var draw_vect=function(p,v) {
  var d=vp(v);
  var m=mp(p);
  for(var i=0; i<2; i++) {
    ctx.beginPath();
    ctx.moveTo(m.x,m.y);
    ctx.lineTo(m.x+d.x,m.y+d.y);
    ctx.moveTo(m.x+d.x*0.8-d.y*0.15,m.y+d.y*0.8+d.x*0.15);
    ctx.lineTo(m.x+d.x,m.y+d.y);
    ctx.lineTo(m.x+d.x*0.8+d.y*0.15,m.y+d.y*0.8-d.x*0.15);
    ctx.stroke();
    ctx.beginPath();
    ctx.arc(m.x,m.y,5,0,tau);
    ctx.fill();
  }
}

var draw=function() {
  ctx.clearRect(0,0,canvas.width,canvas.height);
  ctx.lineWidth=2;

  var N1=curve.length;

  ctx.fillStyle="red";
/*  ctx.beginPath();
  ctx.arc(m.x,m.y,4,0,tau);
  ctx.fill();*/
  ctx.strokeStyle="red";
  var ve={x:curve[1].x-curve[0].x,y:curve[1].y-curve[0].y};
  var d=norm(ve);
  d=0.5/d;
//  var d=N1/5;
  ve.x *= d;
  ve.y *= d;
//  draw_vect(curve[0],{x:0,y:0.5});
  draw_vect(curve[0],ve);
  draw_vect({x:2*curve[N1-1].x-curve[0].x, y:2*curve[N1-1].y-curve[0].y}, ve);

  ctx.strokeStyle="black";
  ctx.beginPath();
  var c=curve[0];
  var m0=mp({x:c.x-X0,y:c.y});
  var m1=mp(c);
  ctx.moveTo(m0.x,m0.y);
  ctx.lineTo(m1.x,m1.y);
  for(var i=1; i<N1; i++) {
    m=mp(curve[i]);
    ctx.lineTo(m.x,m.y);
  }
  ctx.stroke();
  
  var c=mp(curve[N1-1]);
  
  ctx.strokeStyle="blue";
  ctx.beginPath();
  ctx.moveTo(2*c.x-m0.x,2*c.y-m0.y);
  ctx.lineTo(2*c.x-m1.x,2*c.y-m1.y);
  for(var i=1; i<N1; i++) {
    m=mp(curve[i]);
    ctx.lineTo(2*c.x-m.x,2*c.y-m.y);
  }
  ctx.stroke();
}

var update=function(ev) {
  WG(sliderUnfold.value/sliderUnfold.max);
  draw();
}

var cbCorrect1=document.getElementById("cbCo1");
var cbCorrect2=document.getElementById("cbCo2");
cbCorrect1.checked=false;
cbCorrect2.checked=false;
cbCorrect1.onchange = update;
cbCorrect2.onchange = update;

var sliderUnfold=document.getElementById("sliderBM2");
sliderUnfold.value = sliderUnfold.max;
sliderUnfold.oninput = update;

WG(sliderUnfold.value/sliderUnfold.max);
draw();
}