function evert1(slide) {

var cut=false;
var input1=document.getElementById("input1");
input1.onchange=function () {
  cut=input1.checked;
};

//var slide = document.getElementById(id);
var wi=slide.clientWidth-100;
var he=slide.clientHeight-100;

var sceneFirst = new THREE.Scene();
var cameraFirst = new THREE.PerspectiveCamera( 25, wi/he, 0.1, 1000 );
cameraFirst.up.set(0,0,1);
cameraFirst.position.set(0,5,1);
cameraFirst.lookAt(new THREE.Vector3(0,0,0));

var rendererFirst = new THREE.WebGLRenderer( { alpha: true });
rendererFirst.setSize(wi,he);
var domel=rendererFirst.domElement;
slide.appendChild(domel);
setStyle(domel,{ "position":"absolute", "left":"50px", "bottom":"0px"})
//  domel.style["transform"]="translateZ(100px)";
//  setStyle(domel, { "transform": "translateZ(100px)", "perspective": "600px"});

var controlsFirst = new THREE.OrbitControls( cameraFirst, domel );
    controlsFirst.target.set( 0, 0, 0 );
    controlsFirst.enableKeys=false;
    controlsFirst.update();
      

var planeFirst = new THREE.Plane( new THREE.Vector3( -1, 0, 0 ), 10.0 );
rendererFirst.localClippingEnabled = true;

var dirLight = new THREE.DirectionalLight( 0xFFFFFF, 0.6 );
dirLight.position.set( 2, 3, 5 );
dirLight.castShadow = false;
sceneFirst.add( dirLight );
      
var ambLight = new THREE.AmbientLight( 0xFFFFFF, 0.4 );
sceneFirst.add( ambLight );

var meshFirst = new THREE.Geometry();
//meshFirst.dynamic=true;
var NB_LAT=40;
var NB_LONG=80;
var tau=2*Math.PI;
meshFirst.vertices.push(new THREE.Vector3(0,0,-1));
meshFirst.vertices.push(new THREE.Vector3(0,0,1));
for(var i=0; i<=NB_LAT; i++) {
  for(var j=0; j<NB_LONG; j++) {
    var phi=(i/NB_LAT-0.5)*tau/2;
    var theta=j/NB_LONG*tau;
    meshFirst.vertices.push(new THREE.Vector3(
      Math.cos(phi)*Math.cos(theta),
      Math.cos(phi)*Math.sin(theta),
      Math.sin(phi)
    ));
  }
}
//  meshFirst.computeVertexNormals();
for(var i=0; i<NB_LAT; i++) {
  for(var j=0; j<NB_LONG; j++) {
    meshFirst.faces.push(new THREE.Face3(
      2+i*NB_LONG+j,
      2+i*NB_LONG+((j+1)%NB_LONG),
      2+(i+1)*NB_LONG+((j+1)%NB_LONG)
    ));
    meshFirst.faces.push(new THREE.Face3(
      2+i*NB_LONG+j,
      2+(i+1)*NB_LONG+((j+1)%NB_LONG),
      2+(i+1)*NB_LONG+j
    ));
  }
}
/*for(var j=0; j<NB_LONG; j++) {
  meshFirst.faces.push(new THREE.Face3(
    0,
    2+(i+1)*NB_LONG+((j+1)%NB_LONG),
    2+(i+1)*NB_LONG+j
  ));
  meshFirst.faces.push(new THREE.Face3(
    2+i*NB_LONG+j,
    2+i*NB_LONG+((j+1)%NB_LONG),
    1
  ));
}*/
meshFirst.computeVertexNormals();

var material = new THREE.MeshLambertMaterial( {
          color: 0x80ee10,
          
          side: THREE.BackSide,

          // ***** Clipping setup (material): *****
          clippingPlanes: [ planeFirst ],
//						clipShadows: true

        } );
var material2 = new THREE.MeshLambertMaterial( {
          color: 0xee8010,
          
          side: THREE.FrontSide,

          // ***** Clipping setup (material): *****
          clippingPlanes: [ planeFirst ],
//						clipShadows: true

        } );
//  var material = new THREE.MeshBasicMaterial( { color: 0x00ff00 } );
var sph = new THREE.Mesh( meshFirst, material );
sceneFirst.add( sph );
var sph_in = new THREE.Mesh( meshFirst, material2 );
sceneFirst.add( sph_in );

var stopRenderFirst=false;

var timeFirst=0;

//   var params = { cut: false };
//  var gui=new dat.GUI();
//  gui.add(params,'cut');
var renderFirst = function () {
  if(!stopRenderFirst) requestAnimationFrame( renderFirst );

  timeFirst+=0.75/60;
  var h=(1-Math.cos(timeFirst))/2;
  if(cut)
    planeFirst.constant=0.;
  else
    planeFirst.constant=10.;
  cut;
  
  v=meshFirst.vertices; 
  for(var i=0; i<=NB_LAT; i++) {
    var phi=tau/2*(-0.5+i/NB_LAT);
    var x=Math.cos(phi);
    var y=Math.sin(phi);
    for(var j=0; j<NB_LONG; j++) {
      v[2+i*NB_LONG+j].setZ(y-h*(1-0.5*x*x)*y*2);
    }
  }
  meshFirst.computeVertexNormals();
  meshFirst.verticesNeedUpdate=true;

  rendererFirst.render(sceneFirst, cameraFirst);
};

var slideFirstEnter = function() {
  stopRenderFirst=false;
  renderFirst();
}
var slideFirstLeave = function() {
  stopRenderFirst=true;
}
slide.addEventListener("impress:stepenter",slideFirstEnter,false);
slide.addEventListener("impress:stepleave",slideFirstLeave,false);
};