function evert3(slide) {
var tau=2*Math.PI;

var showS=true;
var showI=false;
var inputS=document.getElementById("cbBasicSurf");
var inputI=document.getElementById("cbBasicInter");
inputS.checked=showS;
inputI.checked=showI;
inputS.onchange=function () {  showS=inputS.checked;  shape.visible=showS; shape_in.visible=showS; };
inputI.onchange=function () {  showI=inputI.checked;  shape_inter.visible=showI; };

var wi=slide.clientWidth-100;
var he=slide.clientHeight-200;

var scene = new THREE.Scene();
var camera = new THREE.PerspectiveCamera( 35, wi/he, 0.1, 1000 );
camera.up.set(0,0,1);
camera.position.set(0,7,0);
camera.lookAt(new THREE.Vector3(0,0,0));

var renderer = new THREE.WebGLRenderer( { alpha: true });
renderer.setSize(wi,he);
var domel=renderer.domElement;
slide.appendChild(domel);
setStyle(domel,{ "position":"absolute", "left":"50px", "bottom":"50px"})

var slider=document.getElementById("sliderBasic");
slider.value=slider.max;

var controls = new THREE.OrbitControls( camera, domel );
    controls.target.set( 0, 0, 0 );
    controls.enableKeys=false;
    controls.update();

var plane = new THREE.Plane( new THREE.Vector3( 0, 0, -1 ), 10.0 );
renderer.localClippingEnabled = true;

var dirLight1 = new THREE.DirectionalLight( 0xFFFFDD, 0.6 );
var dirLight2 = new THREE.DirectionalLight( 0xFFDDFF, 0.6 );
var posLight1=new THREE.Vector3(-1, 3, 5);
var posLight2=new THREE.Vector3( -2, -4, -4 );
dirLight1.position.copy(posLight1);
dirLight2.position.copy(posLight2);
dirLight1.castShadow = false;
dirLight2.castShadow = false;
scene.add( dirLight1 );
scene.add( dirLight2 );
      
var ambLight = new THREE.AmbientLight( 0xFFFFFF, 0.4 );
scene.add( ambLight );

var loader=new THREE.OBJLoader();
var mesh=new THREE.Geometry();
var ok=false;
var shape,shape_in,shape_inter;

loader.load("meshes/7.obj",function ( object ) {
    var mesh;
    object.traverse( function ( child ) {
        if ( child instanceof THREE.Mesh ) {
            mesh=child.geometry;
        }
    } );
//    mesh.computeFaceNormals();
    mesh.computeVertexNormals();
    shape = new THREE.Mesh(mesh,material);
    scene.add( shape );
    shape_in = new THREE.Mesh(mesh,material2);    
    scene.add( shape_in );
    shape.translateZ(-2);
    shape_in.translateZ(-2);
    shape.visible=showS;
    shape_in.visible=showS;
	}
);

loader.load("meshes/Noeud-Pap.obj",function ( object ) {
    var inter_mesh;
    object.traverse( function ( child ) {
        if ( child instanceof THREE.Mesh ) {
            inter_mesh=child.geometry;
        }
    } );
//    mesh.computeFaceNormals();
//    mesh.computeVertexNormals(); // file includes normals
    shape_inter = new THREE.Mesh(inter_mesh,material3);
    scene.add( shape_inter );
    shape_inter.translateZ(1);
    shape_inter.visible=showI;
	}
);

var material = new THREE.MeshLambertMaterial( {
          color: 0x80ee10,
          
          side: THREE.BackSide,

          // ***** Clipping setup (material): *****
          clippingPlanes: [ plane ],
//						clipShadows: true

        } );
var material2 = new THREE.MeshLambertMaterial( {
          color: 0xee8010,
          
          side: THREE.FrontSide,

          // ***** Clipping setup (material): *****
          clippingPlanes: [ plane ],
//						clipShadows: true

        } );
var material3 = new THREE.MeshLambertMaterial( {
          color: 0xA00080,
          
          side: THREE.DoubleSide,

          // ***** Clipping setup (material): *****
          clippingPlanes: [ plane ],
//						clipShadows: true

        } );

var stopRender=false;

var render = function () {
  if(!stopRender) requestAnimationFrame( render );

  /*var phi=-(tau/4-controls.getPolarAngle());
  var theta=controls.getAzimuthalAngle()+tau/4;

  var m1=new THREE.Matrix4();
  var m2=new THREE.Matrix4();
  var m=new THREE.Matrix4();
  m1.makeRotationZ(theta);
  m2.makeRotationY(-phi);
  m.multiplyMatrices(m1,m2);

  dirLight1.position.copy(posLight1);
  dirLight2.position.copy(posLight2);
  dirLight1.position.applyMatrix4(m);
  dirLight2.position.applyMatrix4(m);*/

  var t=slider.value/slider.max;
  t=2*t-1;
  t=2*t;
  plane.constant=t;

  renderer.render(scene, camera);
};

var slideEnter = function() {
  stopRender=false;
  render();
}
var slideLeave = function() {
  stopRender=true;
}
slide.addEventListener("impress:stepenter",slideEnter,false);
slide.addEventListener("impress:stepleave",slideLeave,false);
};