function evert4(slide) {

var cut=false;
var input=document.getElementById("cutPoke");
input.checked=false;
input.onchange=function () {
  cut=input.checked; 
};

var wi=slide.clientWidth-200;
var he=slide.clientHeight-200;

var scene = new THREE.Scene();
var camera = new THREE.PerspectiveCamera( 20, wi/he, 0.1, 1000 );
camera.up.set(0,0,1);
camera.position.set(0,7,0);
camera.lookAt(new THREE.Vector3(0,0,0));

var renderer = new THREE.WebGLRenderer( { alpha: true });
renderer.setSize(wi,he);
var domel=renderer.domElement;
slide.appendChild(domel);
setStyle(domel,{ "position":"absolute", "left":"100px", "bottom":"50px"})
domel.classList.add("reveal");

var slider=document.getElementById("sliderPoke");
slider.value=0;

var controls = new THREE.OrbitControls( camera, domel );
    controls.target.set( 0, 0, 0 );
    controls.enableKeys=false;
    controls.update();

var plane = new THREE.Plane( new THREE.Vector3( 0, -1, 0 ), 0.0 );
renderer.localClippingEnabled = true;

var dirLight1 = new THREE.DirectionalLight( 0xAAFFFF, 0.6 );
var dirLight2 = new THREE.DirectionalLight( 0xFFFFAA, 0.6 );
var posLight1=new THREE.Vector3(-1, 3, 5);
var posLight2=new THREE.Vector3( -2, -4, -4 );
dirLight1.position.copy(posLight1);
dirLight2.position.copy(posLight2);
dirLight1.castShadow = false;
dirLight2.castShadow = false;
scene.add( dirLight1 );
scene.add( dirLight2 );
      
var ambLight = new THREE.AmbientLight( 0xFFFFFF, 0.4 );
scene.add( ambLight );

var mesh = new THREE.Geometry();

var NB_LAT=60;
var NB_LONG=120;
var gap=0.125;

var tau=2*Math.PI;
mesh.vertices.push(new THREE.Vector3(0,0,-1));

var phiGap=gap*tau/2;
var cosPhiGap=Math.cos(phiGap);
var sinPhiGap=Math.sin(phiGap);
for(var i=0; i<=NB_LAT; i++) {
  for(var j=0; j<NB_LONG; j++) {
    var t=(i+1)/(NB_LAT+1);
    t=(1-gap)*t;
    var phi=(t-0.5)*tau/2;
    var theta=j/NB_LONG*tau;
    mesh.vertices.push(new THREE.Vector3(
      Math.cos(phi)*Math.cos(theta),
      Math.cos(phi)*Math.sin(theta),
      Math.sin(phi)
    ));
  }
}

var cos_theta_=[];
var sin_theta_=[];
var cos_phi_=[];
var sin_phi_=[];
for(var i=-1; i<=NB_LAT; i++) {
  var t=(i+1)/(NB_LAT+1);
  t=(1-gap)*t;
  var phi=(t-0.5)*tau/2;
  cos_phi_.push(Math.cos(phi));
  sin_phi_.push(Math.sin(phi));
}
for(var j=0; j<NB_LONG; j++) {
  var theta=j/NB_LONG*tau;
  cos_theta_.push(Math.cos(theta));
  sin_theta_.push(Math.sin(theta));
}

var offset=0;

offset=mesh_push_disk(mesh,NB_LAT,NB_LONG,offset);

mesh.computeVertexNormals();

var material = new THREE.MeshLambertMaterial( {
          color: 0x80ee10,
          
          side: THREE.BackSide,

          // ***** Clipping setup (material): *****
          clippingPlanes: [ plane ],
//						clipShadows: true

        } );
var material2 = new THREE.MeshLambertMaterial( {
          color: 0xee8010,
          
          side: THREE.FrontSide,

          // ***** Clipping setup (material): *****
          clippingPlanes: [ plane ],
//						clipShadows: true

        } );
var shape = new THREE.Mesh( mesh, material2 );
scene.add( shape );
var shape_in = new THREE.Mesh( mesh, material );
scene.add( shape_in );

shape.rotateY( Math.PI / 2);
shape_in.rotateY( Math.PI / 2);
  
var stopRender=false;

function moset(j,i,c,s,f,v) {
//  var x=Math.cos(tau/4-phi);
//  var y=Math.sin(tau/4-phi);
  var x=sin_phi_[i+1];
  var y=cos_phi_[i+1];
  
  x=(x-cosPhiGap)/sinPhiGap;
  y=y/sinPhiGap;
  
  var z={re:x,im:y}; 
//  z=div(add(scale(c,z),{re:s,im:0}),add({re:c,im:0},scale(-s,z)));

  z=div(add(z,{re:0,im:-1}),add(z,{re:0,im:1})); 

  var l=0.5*Math.log(Norm(z));
  var nl=l+(f-1)*Math.tanh(l*5)/5;
  z=scale(Math.exp(nl-l),z);
  
  z=mul(z,{re:2*c*c-1,im:2*s*c});
    
  z=mul({re:0,im:-1},div(add(z,{re:1,im:0}),add(z,{re:-1,im:0})));
  
  x=z.re;
  y=z.im;
  
  x=(x*sinPhiGap+cosPhiGap);
  y=y*sinPhiGap;
  
  v.x=y*cos_theta_[j];
  v.y=y*sin_theta_[j];
  v.z=x;
}

/*function slideFunc(ti,t) {
  if(ti==0) return 0;
  if(ti==1) return 1;
  var mu=ti;
  mu=mu/(1-mu);
  mu=Math.log(mu);
  mu=mu+t;
  mu=Math.exp(mu);
  mu=mu/(1+mu);
  return mu;
}*/
/*
function compMu(ti,t) {
  if(ti==0) return 0;
  if(ti==1) return 1;
//  var u=Math.exp(4*Math.log(t+0.0001));
  var u=0.05*t*t+0.95*t*t*t*t;
  var la=Math.exp(-8*u);
  var mu=ti;
  mu=mu/(1-mu);
  mu=mu*la;
  mu=mu/(1+mu);
  return mu;
}
*/
/*
function compMu(ti,t) {
  if(ti==0) return 0;
  if(ti>0.99) return 1;
//  var u=Math.exp(4*Math.log(t+0.0001));
  var u=Math.sqrt(t*t+0.01)-0.1;
  var la=Math.exp(-u*30);
  var mu=1-Math.exp(Math.log(1-ti)*6);
  mu=mu/(1-mu);
  mu=mu*la;
  mu=mu/(1+mu);
  return mu;
}*/

function compMu(ti,t) {
  if(ti==0) return 0;
  if(ti>0.99) return 1;
//  var u=Math.exp(4*Math.log(t+0.0001));
  var u=Math.sqrt(t*t+0.01)-0.1;
  var la=Math.exp(-u*30);
  var mu=1-Math.exp(Math.log(1-ti)*6);
  mu=mu*mu;
  mu=mu/(1-mu);
  mu=mu*la;
  mu=mu/(1+mu);
  return mu;
}
var render = function () {
  if(!stopRender) requestAnimationFrame( render );

  var phi=-(tau/4-controls.getPolarAngle());
  var theta=controls.getAzimuthalAngle()+tau/4;
    
  var m1=new THREE.Matrix4();
  var m2=new THREE.Matrix4();
  var m=new THREE.Matrix4();
  m1.makeRotationZ(theta);
  m2.makeRotationY(-phi);
  m.multiplyMatrices(m1,m2);

  dirLight1.position.copy(posLight1);
  dirLight2.position.copy(posLight2);
  dirLight1.position.applyMatrix4(m);
  dirLight2.position.applyMatrix4(m);

  var ti = slider.value/slider.max;

  if(cut)
    plane.constant=0;
  else
    plane.constant=10.;
  
  var ve=mesh.vertices; 

  var mu=compMu(ti,0);
  var c=Math.cos((1-gap)*mu*tau/2);
  var s=Math.sin((1-gap)*mu*tau/2);
  var x0=(-1-cosPhiGap)/sinPhiGap;
  var f=c-s*x0;
  f=Math.abs(f);
  f=Math.exp(1.33*Math.log(f));
//  f=f*f;
  moset(0,-1,c,s,f,ve[0]);
  for(var i=0; i<=NB_LAT; i++) {
    var t=(i+1)/(NB_LAT+1);
    var mu=compMu(ti,t);
    var c=Math.cos((1-gap)*mu*tau/2);
    var s=Math.sin((1-gap)*mu*tau/2);
    var x0=(-1-cosPhiGap)/sinPhiGap;
    var f=c-s*x0;
    f=Math.abs(f);
//    f=f*f;
  f=Math.exp(1.33*Math.log(f));
    for(var j=0; j<NB_LONG; j++) {
      var k=1+i*NB_LONG+j;
      moset(j,i,c,s,f,ve[k]);
    }
  }/*
  var tr=(ve[0].z+ve[(1+NB_LAT)*NB_LONG].z)/2;
  for(var k=0; k<1+(1+NB_LAT)*NB_LONG; k++)
      ve[k].z -= tr;*/
  mesh.center();
  
  mesh.computeVertexNormals();
  mesh.verticesNeedUpdate=true;
  
  renderer.render(scene, camera);
};

var slideEnter = function() {
  stopRender=false;
  render();
}
var slideLeave = function() {
  stopRender=true;
}
slide.addEventListener("impress:stepenter",slideEnter,false);
slide.addEventListener("impress:stepleave",slideLeave,false);
};