function evert5(slide) {

var cut=false;
var input=document.getElementById("cutEars");
input.checked=false;
input.onchange=function () {
  cut=input.checked; 
};

var showS=true;
var showI=false;
var inputS=document.getElementById("cbNoseSurf");
var inputI=document.getElementById("cbNoseInter");
inputS.checked=showS;
inputI.checked=showI;
inputS.onchange=function () {  showS=inputS.checked;  shape.visible=showS; shape_in.visible=showS; };
inputI.onchange=function () {  showI=inputI.checked;  shape_inter.visible=showI; };

/*
var textFile = null,
  makeTextFile = function (text) {
    var data = new Blob([text], {type: 'text/plain'});

    // If we are replacing a previously generated file we need to
    // manually revoke the object URL to avoid memory leaks.
    if (textFile !== null) {
      window.URL.revokeObjectURL(textFile);
    }

    textFile = window.URL.createObjectURL(data);

    // returns a URL you can use as a href
    return textFile;
  };
  */
/*var button=document.getElementById("export");
button.onclick=function () {
  var ex=new THREE.OBJExporter();
  var output=ex.parse(shape);
  window.open(makeTextFile(output));
};*/



var wi=slide.clientWidth-100;
var he=slide.clientHeight-50;

var scene = new THREE.Scene();
var camera = new THREE.PerspectiveCamera( 20, wi/he, 0.1, 1000 );
camera.up.set(0,0,1);
camera.position.set(0,7,0);
camera.lookAt(new THREE.Vector3(0,0,0));

var renderer = new THREE.WebGLRenderer( { alpha: true });
renderer.setSize(wi,he);
var domel=renderer.domElement;
slide.appendChild(domel);
setStyle(domel,{ "position":"absolute", "left":"50px", "bottom":"0px"})

var slider=document.getElementById("sliderEars");
slider.value=0;

var controls = new THREE.OrbitControls( camera, domel );
    controls.target.set( 0, 0, 0 );
    controls.enableKeys=false;
    controls.update();

var plane = new THREE.Plane( new THREE.Vector3( 0, -1, 0 ), 10.0 );
renderer.localClippingEnabled = true;

var dirLight1 = new THREE.DirectionalLight( 0xAAFFFF, 0.6 );
var dirLight2 = new THREE.DirectionalLight( 0xFFFFAA, 0.6 );
var posLight1=new THREE.Vector3(-1, 3, 5);
var posLight2=new THREE.Vector3( -2, -4, -4 );
dirLight1.position.copy(posLight1);
dirLight2.position.copy(posLight2);
dirLight1.castShadow = false;
dirLight2.castShadow = false;
scene.add( dirLight1 );
scene.add( dirLight2 );
      
var ambLight = new THREE.AmbientLight( 0xFFFFFF, 0.4 );
scene.add( ambLight );

var loader=new THREE.OBJLoader();
var mesh=new THREE.Geometry();
var ok=false;
var shape_inter;

loader.load("meshes/inter-2.obj",function ( object ) {
    var inter_mesh;
    object.traverse( function ( child ) {
        if ( child instanceof THREE.Mesh ) {
            inter_mesh=child.geometry;
        }
    } );
//    mesh.computeFaceNormals();
//    mesh.computeVertexNormals(); // file includes normals
    shape_inter = new THREE.Mesh(inter_mesh,material3);
    scene.add( shape_inter );
    shape_inter.visible=showI;
	}
);

var material3 = new THREE.MeshLambertMaterial( {
          color: 0xA00080,
          
          side: THREE.DoubleSide,

          // ***** Clipping setup (material): *****
          clippingPlanes: [ plane ],
//						clipShadows: true

        } );

var mesh = new THREE.Geometry();

var NB_LAT=60;
var NB_LONG=120;

var tau=2*Math.PI;

var cos_theta_=[];
var sin_theta_=[];
var cos_phi_=[];
var sin_phi_=[];
for(var i=0; i<=NB_LAT; i++) {
  var t=i/NB_LAT;
  var phi=(t-0.5)*tau/2;
  cos_phi_.push(Math.cos(phi));
  sin_phi_.push(Math.sin(phi));
}
for(var j=0; j<NB_LONG; j++) {
  var theta=j/NB_LONG*tau;
  cos_theta_.push(Math.cos(theta));
  sin_theta_.push(Math.sin(theta));
}

orig=[];

for(var i=0; i<=NB_LAT; i++) {
  for(var j=0; j<NB_LONG; j++) {
    var v=new THREE.Vector3(
      cos_phi_[i]*cos_theta_[j],
      cos_phi_[i]*sin_theta_[j],
      sin_phi_[i]
    );
    orig.push(v);
    mesh.vertices.push(v.clone());
  }
}

var offset=0;

offset=mesh_push_cyl(mesh,NB_LAT,NB_LONG,offset);

mesh.computeVertexNormals();

var material = new THREE.MeshLambertMaterial( {
          color: 0x80ee10,
          
          side: THREE.BackSide,

          // ***** Clipping setup (material): *****
          clippingPlanes: [ plane ],
//						clipShadows: true

        } );
var material2 = new THREE.MeshLambertMaterial( {
          color: 0xee8010,
          
          side: THREE.FrontSide,

          // ***** Clipping setup (material): *****
          clippingPlanes: [ plane ],
//						clipShadows: true

        } );
var shape = new THREE.Mesh( mesh, material2 );
scene.add( shape );
var shape_in = new THREE.Mesh( mesh, material );
scene.add( shape_in );
//scene.add(shape_inter);

//shape.rotateY( Math.PI / 2);
//shape_in.rotateY( Math.PI / 2);
  
var stopRender=false;

var render = function () {
  if(!stopRender) requestAnimationFrame( render );

  var phi=-(tau/4-controls.getPolarAngle());
  var theta=controls.getAzimuthalAngle()+tau/4;
    
  var m1=new THREE.Matrix4();
  var m2=new THREE.Matrix4();
  var m=new THREE.Matrix4();
  m1.makeRotationZ(theta);
  m2.makeRotationY(-phi);
  m.multiplyMatrices(m1,m2);

  dirLight1.position.copy(posLight1);
  dirLight2.position.copy(posLight2);
  dirLight1.position.applyMatrix4(m);
  dirLight2.position.applyMatrix4(m);

  var ti = slider.value/slider.max;

  if(cut)
    plane.constant=0;
  else
    plane.constant=10.;
  
  var ve=mesh.vertices; 

  var mu=Math.min(3*ti,1);
  var nu=Math.max(Math.min(3*ti-1,1),0); 
  var ta=Math.max(Math.min(3*ti-2,1),0); 
  var w=new THREE.Vector3(1,0,0.9);
  w.normalize();
  for(var i=0; i<=NB_LAT; i++) {
    for(var j=0; j<NB_LONG; j++) {
      var k=i*NB_LONG+j;
      ve[k].x=orig[k].x*(1-mu*0.5);
      ve[k].y=orig[k].y*(1-mu*0.1);
      ve[k].z=orig[k].z*(1-mu*0.65);
      var h=1+orig[k].z;
      h=Math.exp(-8*h*Math.sqrt(h));
      ve[k].z += 1.2*nu*h;
      var aux=orig[k].clone();
      aux.y *= 0.666;
      aux.normalize();
      var dot=aux.dot(w);
      h=1+dot;
      h=Math.exp(-30*h*Math.sqrt(h));
      ve[k].x += 1.*ta*h;
      ve[k].z += -1.*0.2*ta*h;
    }
  }
//  mesh.center();
  
  mesh.verticesNeedUpdate=true;
  mesh.computeVertexNormals();
  
  renderer.render(scene, camera);
};

var slideEnter = function() {
  stopRender=false;
  render();
}
var slideLeave = function() {
  stopRender=true;
}
slide.addEventListener("impress:stepenter",slideEnter,false);
slide.addEventListener("impress:stepleave",slideLeave,false);
};