function evert8(slide) {
var tau=2*Math.PI;

var wi=slide.clientWidth-100;
var he=slide.clientHeight-100;

var scene = new THREE.Scene();
var camera = new THREE.PerspectiveCamera( 25, wi/he, 0.01, 1000 );
camera.up.set(0,0,1);
camera.position.set(0,12,0);
camera.lookAt(new THREE.Vector3(0,0,0));

var renderer = new THREE.WebGLRenderer( { alpha: true });
renderer.setSize(wi,he);
var domel=renderer.domElement;
slide.appendChild(domel);
setStyle(domel,{ "position":"absolute", "left":"50px", "bottom":"0px"})

var slider=document.getElementById("sliderOeuf2");
slider.value=slider.max;

var controls = new THREE.OrbitControls( camera, domel );
    controls.target.set( 0, 0, 0 );
    controls.enableKeys=false;
    controls.update();

var plane = new THREE.Plane( new THREE.Vector3( 0, 0, -1 ), 10.0 );
var plane2 = new THREE.Plane( new THREE.Vector3( 0, 0, 1 ), 10.0 );
renderer.localClippingEnabled = true;

var dirLight1 = new THREE.DirectionalLight( 0xFFFFDD, 0.6 );
var dirLight2 = new THREE.DirectionalLight( 0xFFDDFF, 0.6 );
var posLight1=new THREE.Vector3(-1, 3, 5);
var posLight2=new THREE.Vector3( -2, -4, -4 );
dirLight1.position.copy(posLight1);
dirLight2.position.copy(posLight2);
dirLight1.castShadow = false;
dirLight2.castShadow = false;
scene.add( dirLight1 );
scene.add( dirLight2 );
      
var ambLight = new THREE.AmbientLight( 0xFFFFFF, 0.4 );
scene.add( ambLight );

var loader=new THREE.OBJLoader();
var mesh=new THREE.Geometry();
var ok=false;
var shape,shape_in;

loader.load("meshes/Oeuf-2.obj",function ( object ) {
    var mesh;
    object.traverse( function ( child ) {
        if ( child instanceof THREE.Mesh ) {
            mesh=child.geometry;
        }
    } );
//    mesh.computeFaceNormals();
    mesh.scale(1,1,-1);
    mesh.computeVertexNormals();
    shape = new THREE.Mesh(mesh,material);
    scene.add( shape );
    shape_in = new THREE.Mesh(mesh,material2);    
    scene.add( shape_in );
	}
);

var material = new THREE.MeshLambertMaterial( {
          color: 0x80ee10,
          
          side: THREE.BackSide,

          // ***** Clipping setup (material): *****
          clippingPlanes: [ plane,plane2 ],
//						clipShadows: true

        } );
var material2 = new THREE.MeshLambertMaterial( {
          color: 0xee8010,
          
          side: THREE.FrontSide,

          // ***** Clipping setup (material): *****
          clippingPlanes: [ plane, plane2 ],
//						clipShadows: true

        } );
var material3 = new THREE.MeshLambertMaterial( {
          color: 0xffff20,
          side: THREE.DoubleSide,
        } );

var mesh_plane=new THREE.Geometry();
mesh_plane.vertices.push(new THREE.Vector3(0,0,0));
for(var i=0; i<60; i++) {
  var r=1.3;
  var th=tau*i/60;
  mesh_plane.vertices.push(new THREE.Vector3(r*Math.cos(th),r*Math.sin(th),0));
  mesh_plane.faces.push(new THREE.Face3(0,1+i,1+(i+1)%60));
}
var shape_plane=new THREE.Mesh(mesh_plane, material3);
scene.add(shape_plane);

var stopRender=false;

var render = function () {
  if(!stopRender) requestAnimationFrame( render );

  var phi=-(tau/4-controls.getPolarAngle());
  var theta=controls.getAzimuthalAngle()+tau/4;

  var m1=new THREE.Matrix4();
  var m2=new THREE.Matrix4();
  var m=new THREE.Matrix4();
  m1.makeRotationZ(theta);
  m2.makeRotationY(-phi);
  m.multiplyMatrices(m1,m2);

  dirLight1.position.copy(posLight1);
  dirLight2.position.copy(posLight2);
  dirLight1.position.applyMatrix4(m);
  dirLight2.position.applyMatrix4(m);

  var t=slider.value/slider.max;
  t=2*t-1;
  t=2*t;
//   var ve=mesh_plane.vertices;
//   for(var i=0; i<ve.length; i++) {
//     ve[i].z=t;
//   }
  shape_plane.position.set(0,0,t);
  plane.constant=t+0.02;
  mesh_plane.verticesNeedUpdate=true;
  mesh_plane.computeVertexNormals();

  renderer.render(scene, camera);
};

var slideEnter = function() {
  stopRender=false;
  render();
}
var slideLeave = function() {
  stopRender=true;
}
slide.addEventListener("impress:stepenter",slideEnter,false);
slide.addEventListener("impress:stepleave",slideLeave,false);
};