function evert9(slide) {
var tau=2*Math.PI;

var N1=2;
var N2=200;

var wi=slide.clientWidth-100;
var he=slide.clientHeight-100;

var scene = new THREE.Scene();
var camera = new THREE.PerspectiveCamera( 25, wi/he, 0.01, 1000 );
camera.up.set(0,0,1);
camera.position.set(0,6,1.5);
camera.lookAt(new THREE.Vector3(0,0,0));

var renderer = new THREE.WebGLRenderer( { alpha: true });
renderer.setSize(wi,he);
var domel=renderer.domElement;
slide.appendChild(domel);
setStyle(domel,{ "position":"absolute", "left":"50px", "bottom":"50px"})
domel.classList.add("reveal");

var controls = new THREE.OrbitControls( camera, domel );
    controls.target.set( 0, 0, 0 );
    controls.enableKeys=false;
    controls.update();

var dirLight1 = new THREE.DirectionalLight( 0xFFFFDD, 0.6 );
var dirLight2 = new THREE.DirectionalLight( 0xFFDDFF, 0.6 );
var posLight1=new THREE.Vector3(-1, 3, 5);
var posLight2=new THREE.Vector3( -2, -4, -4 );
dirLight1.position.copy(posLight1);
dirLight2.position.copy(posLight2);
dirLight1.castShadow = false;
dirLight2.castShadow = false;
scene.add( dirLight1 );
scene.add( dirLight2 );
      
var ambLight = new THREE.AmbientLight( 0xFFFFFF, 0.4 );
scene.add( ambLight );

var material = new THREE.MeshLambertMaterial( {
          color: 0x80ee10,
          side: THREE.BackSide,
        } );
var material2 = new THREE.MeshLambertMaterial( {
          color: 0xee8010,
          side: THREE.FrontSide,
        } );

var mesh=new THREE.Geometry();
var arc=1.0;
var r0=arc/tau;
for(var i=0; i<=N1; i++) {
  var y=i/N1;
  y=2*y-1;
  var x,z;
  for(var j=0; j<=N2; j++) {
    var t=j/N2;
    t=2*t-1;
    t=t*(1+arc/2);
    if(t<-arc/2) { x=t+arc/2; z=0;}
    else if(t>arc/2) { x=t-arc/2; z=0;}
    else { var u=tau*t/arc; x = - r0*Math.sin(u); z=r0*(1+Math.cos(u)); }
    mesh.vertices.push(new THREE.Vector3(x-1,y,z));
  }
}
var offset=0;
offset=mesh_push_rect(mesh,N1,N2,offset);

var arc2=0.66;
var r2=arc2/tau;
for(var i=0; i<=N1; i++) {
  var y=i/N1;
  y=2*y-1;
  var x,z;
  for(var j=0; j<=N2; j++) {
    var t=j/N2;
    t=2*t-1;
    t=t*(1+arc2/2);
    if(t<-arc2/2) { x=t+arc2/2;}
    else if(t>arc2/2) { x=t-arc2/2;}
    else { var u=tau*t/arc2; x = - r2*Math.sin(u); }
    var t=j/N2;
    t=2*t-1;
    t=t*(1+arc/2);
    if(Math.abs(t)>arc/2) { z=0;}
    else { var u=tau*t/arc; z=r0*(1+Math.cos(u)); }
    mesh.vertices.push(new THREE.Vector3(x+1,y,z));
  }
}
offset=mesh_push_rect(mesh,N1,N2,offset);

mesh.computeVertexNormals();

var shape=new THREE.Mesh(mesh, material2);
var shape_in=new THREE.Mesh(mesh, material);
scene.add(shape);
scene.add(shape_in);

var stopRender=false;

var render = function () {
  if(!stopRender) requestAnimationFrame( render );

  var phi=-(tau/4-controls.getPolarAngle());
  var theta=controls.getAzimuthalAngle()+tau/4;

  var m1=new THREE.Matrix4();
  var m2=new THREE.Matrix4();
  var m=new THREE.Matrix4();
  m1.makeRotationZ(theta);
  m2.makeRotationY(-phi);
  m.multiplyMatrices(m1,m2);

  dirLight1.position.copy(posLight1);
  dirLight2.position.copy(posLight2);
  dirLight1.position.applyMatrix4(m);
  dirLight2.position.applyMatrix4(m);

  renderer.render(scene, camera);
};

var slideEnter = function() {
  stopRender=false;
  render();
}
var slideLeave = function() {
  stopRender=true;
}
slide.addEventListener("impress:stepenter",slideEnter,false);
slide.addEventListener("impress:stepleave",slideLeave,false);
};