function roll(id) {
var tau=2*Math.PI;
var SCALE=50;

var norm=function(v) {
  return(Math.sqrt(v.x*v.x+v.y*v.y));
}
function mp(p) {
  return {
    x: canvas.width/2   + SCALE*p.x
   ,y: canvas.height/2  - SCALE*p.y
  };
}
// function vp(v) {
 // return ({x: v.x*SCALE, y:-v.y*SCALE});
// }

var l=1;
var h=l*1.66;
var L=1.5;
var c=l*tau/2;
var T=L+c;
var L2=6;
function loop(t) { // t from -T/2 to T/2
  var y=h*(1+Math.cos(tau*t/T))/2;
  if(t<-c/2) return {x:t+c/2, y:y};
  if(t>c/2) return {x:t-c/2, y:y};
  return {x:-Math.sin(2*t/l)*l/2, y:y};
}
function f(ti) {
  var x,y,t;
  t=ti;
  t=2*t-1;
  t=t*(L2+T);
  if(t<-T) return {x:t+(T-L), y:0};
  else if(t>T) return {x:t-(T-L), y:0};
  else if(t<0) {
    var p=loop(t+T/2);
    return {x:p.x-L/2,y:p.y};
  }
  else {
    var p=loop(t-T/2)
    return {x:p.x+L/2,y:-p.y};
  }
  return {x:x, y:y};  
}

var curve1=[];
var t,x,y;
for(var i=0; i<N1; i++)
  curve1.push(f(i/N1));


var canvas=document.getElementById("roll");
var ctx=canvas.getContext("2d");
var slider=document.getElementById("sliderRoll");
slider.value=0;
var cb=document.getElementById("rollExp");
cb.checked=false;

function drawCurve(curve) {
  ctx.beginPath();
  var m=mp(curve[0]);
  ctx.moveTo(m.x,m.y);
  for(var i=1; i<curve.length; i++) {
    m=mp(curve[i]);
    ctx.lineTo(m.x,m.y);
  }
  ctx.stroke();
}

var draw=function() {
  ctx.clearRect(0,0,canvas.width,canvas.height);
  var cur=slider.value/slider.max;
  if(cur<1E-3) {
    ctx.lineWidth=1;
    ctx.strokeStyle="blue";
    var N=5,M=12;
    var A,t;
    for(var i=-N; i<=N; i++) {
      t=i;
      ctx.beginPath();
      A=mp({x:-M,y:t});
      ctx.moveTo(A.x,A.y);
      A=mp({x:M,y:t});
      ctx.lineTo(A.x,A.y);
      ctx.stroke();
    }
    for(var i=-M; i<=M; i++) {
      t=i;
      ctx.beginPath();
      A=mp({x:t,y:-N});
      ctx.moveTo(A.x,A.y);
      A=mp({x:t,y:N});
      ctx.lineTo(A.x,A.y);
      ctx.stroke();
    }
    ctx.lineWidth=2;
    ctx.strokeStyle="black";
    drawCurve(curve1);
    return;
  }
  ctx.lineWidth=1;
  ctx.strokeStyle="blue";
  var N=5,M=12;
  var r;
  var curve;
  for(var j=-N; j<N; j++) {
    curve=[];
    var y=j;
    if(cb.checked)
      r=Math.exp(-y*cur)/cur;
    else
      r=-y+1/cur;
    if(r>=0) {
      for(var i=0; i<curve1.length; i++) {
        var p=curve1[i];
        if(Math.abs(p.x*cur)<tau/2) {
         curve.push({
          x: r*Math.sin(p.x*cur)
         ,y: 1/cur-r*Math.cos(p.x*cur)
         })
        }
      }
      drawCurve(curve);
    }
  }
  var A,R,th;
  for(var i=-M; i<=M; i++) {
    ctx.beginPath();
    th=i*cur;
    if(Math.abs(th)<=tau/2) {
      r=1/cur+5;
      A=mp({x:r*Math.sin(th),y:1/cur-r*Math.cos(th)});
      ctx.moveTo(A.x,A.y);
      r=Math.max(0,1/cur-5);
      A=mp({x:r*Math.sin(th),y:1/cur-r*Math.cos(th)});
      ctx.lineTo(A.x,A.y);
      ctx.stroke();
    }
  }
  ctx.lineWidth=2;
  ctx.strokeStyle="black";
  curve=[];
  for(var i=0; i<curve1.length; i++) {
    var p=curve1[i];
    if(Math.abs(p.x*cur)<tau/2) {
      if(cb.checked)
        r=Math.exp(-p.y*cur)/cur;
      else
        r=-p.y+1/cur;
      curve.push({
       x: r*Math.sin(p.x*cur)
      ,y: 1/cur-r*Math.cos(p.x*cur)
      })
    }
  }
  drawCurve(curve);
}

slider.oninput=draw;
cb.onchange=draw;
draw();
}